// some graphics utility functions, and drawing of screen 1 (LOOPER) //

#include <stdio.h>
#include <stdlib.h>
#include <vga.h>
#include <vgakeyboard.h>
#include <string.h>
#include <math.h>
#include "CharMap.h"
#include "loopdata.h"
#include "input.h"
#include "gui.h"


int X_SCR1 = 0;
int Y_SCR1 = NUM_LOOPS;
static int BPM = 60;

void switch_screen(int S)
{
	extern int NEW_DISPLAY_SCREEN;
	NEW_DISPLAY_SCREEN = S;
}


const int lb_frame[] = {0, 3, 6, 8, 11, 18, 21, 25, 28, 32,
		35, 37, 40, 44, 47, 49, 52, 54, 57, 58};
int get_bpm() {return BPM;}
int set_bpm(int B) {BPM = B; return 0;}
void leave_box_scr1(int x, int y);
void enter_box_scr1(int x, int y);
void adjust_box_scr1(int x, int y, int delta);
void get_box_scr1(int, int , int * , int * , int *);

void draw_parm_box_scr1(int X, int Y)
{
	int left, right, top;
	int num, lnk;
	char numstr[5];
	get_box_scr1(X, Y, &left, &right, &top);
	if (scr1_parmlink[X-2][Y]== -1)
		{lnk = 0;num = scr1_parms[X-2][Y];}
	else
	{
	lnk = 1; 
	num = mouse_spinner_value[scr1_parmlink[X-2][Y]];
	if (X == 2) // SPEED subtracts 500, is a SIGNED number
		num -= 500;
	scr1_parms[X-2][Y]=num;
	}
	if (X == 2)
		sprintf(numstr, "%03d ", num); // SPEED is signed
	else	sprintf(numstr, "%03d", num);
	DrawStr(numstr, left, top, lnk?0xA0:0x80);
}

void update_parm_boxes_scr1()
{
	int num, X, Y;
	for (X=2;X<8;X++)
		for (Y=0;Y<NUM_LOOPS;Y++)
	{
		if (scr1_parmlink[X-2][Y] != -1)
		{
		num = mouse_spinner_value[scr1_parmlink[X-2][Y]];
		if (X == 2) // SPEED subtracts 500, is a SIGNED number
			num -= 500;
		scr1_parms[X-2][Y]=num;
		}
	}
}

void link_parm_box_scr1(int X, int Y, int FKEY);


void refresh_parm_boxes_scr1()
{
	int i, j;
	for (i=2;i<8;i++)
		for (j=0;j<NUM_LOOPS;j++)
			draw_parm_box_scr1(i,j);
}

void draw_measures_box(int M)
{
	int left, right, top;
	const char * Measure[] = {
		"1/16", "1/8 ", "1/4 ", "1/2 ", "1   ",
		"2   ", "4   ", "8   ", "16  "}; 
	get_box_scr1(1, M, &left, &right, &top);
	DrawStr((char *) Measure[scr1_measures[M]], left, top, 0x80);
}

void draw_record_box(int R)
{
	int X, Y; 
	X = LB_X + 7; Y = LB_Y + 2*R + 2;
	switch (scr1_record[R])
	{
	default:
	case NO_RECORD:	DrawStr(" ", X, Y, 0x00); break;
	case L_DUB: DrawStr("L", X, Y, 0x90); break;
	case R_DUB: DrawStr("R", X, Y, 0x90); break;
	case L_RECORD: DrawStr("L", X, Y, 0xb0); break;
	case R_RECORD: DrawStr("R", X, Y, 0xb0); break;
	};
	
}
	
void draw_fx_box(int FX)
{
	int X, Y, t;
	get_box_scr1(8, FX, &X, &t, &Y);
	switch (scr1_fx[FX])
	{
	default:
	case NO_FX:	DrawStr("N", X, Y, 0x90); break;
	case YES_FX:	DrawStr("Y", X, Y, 0xb0); break;
	};
	 
}


void handle_keyboard_screen1()
{
	int curmove = 0;
	int oldx = X_SCR1;
	int oldy = Y_SCR1;
	int i;
	if (is_pushed(SCANCODE_ENTER) )
	{
		if (oldy < NUM_LOOPS)
			switch_screen(2);
		else
		{
			if (oldx > 0 && oldy == NUM_LOOPS)
				switch_screen(4);
		}
		
	}
	
	if (is_pushed(SCANCODE_BACKSPACE) && oldy < NUM_LOOPS)
		if (isLoopFull(oldy))
	{	
		lockLoop(oldy);
		deleteLoop(oldy);
		unlockLoop(oldy);
		return;
	}
	
	if (is_pushed(SCANCODE_TAB)) switch_screen(3);
	for (i = SCANCODE_F1; i < SCANCODE_F10; i++)
		if (is_pushed(i)) link_parm_box_scr1(oldx, oldy, i);
	if (is_pushed(SCANCODE_INSERT)) {adjust_box_scr1(oldx, oldy, 10);}
	if (is_pushed(SCANCODE_REMOVE))  
		{adjust_box_scr1(oldx,oldy,-10);}
	if (is_pushed(SCANCODE_PAGEUP)) {adjust_box_scr1(oldx, oldy, 1);}
	if (is_pushed(SCANCODE_PAGEDOWN)) {adjust_box_scr1(oldx, oldy, -1);}
	if (is_pushed(SCANCODE_CURSORBLOCKLEFT)) {curmove++;X_SCR1--;}
	if (is_pushed(SCANCODE_CURSORBLOCKRIGHT)) {curmove++;X_SCR1++;}
	if (is_pushed(SCANCODE_CURSORBLOCKUP)) {curmove++;Y_SCR1--;}
	if (is_pushed(SCANCODE_CURSORBLOCKDOWN)) {curmove++;Y_SCR1++;}
	if (curmove)
	{
		X_SCR1 = (X_SCR1<0 || X_SCR1>=SCR_1_CURX)?oldx:X_SCR1;
		Y_SCR1 = (Y_SCR1<0 || Y_SCR1>=SCR_1_CURY)?oldy:Y_SCR1;
		leave_box_scr1(oldx, oldy);
		enter_box_scr1(X_SCR1, Y_SCR1);
	}
	// draw oscillographs //
	for (i=0;i<NUM_LOOPS;i++)
		draw_oscilloscope(i,
			62,
			LB_Y + 2 + 2*i);			
	
}

void link_parm_box_scr1(int X, int Y, int FKEY)
{
	int ms;
	if (X < 2 || X > 7) return;
	if (Y >= NUM_LOOPS) return; 
	ms = FKEY - SCANCODE_F1;
	scr1_parmlink[X-2][Y]=ms;
	scr1_parms[X-2][Y]=mouse_spinner_value[ms];
}


void adjust_box_scr1(int x, int y, int delta)
{
	int i;
	char cBPM[10];
	int l, r, t;
	// mouse spinners
	if (y == NUM_LOOPS + 1)
	{
		if (x > 7) x = 7;
		i = mouse_spinner_axis[x]+ delta;
		if (i<NO_AXIS) i = NO_AXIS;
		if (i>MAX_MOUSESPIN) i = MAX_MOUSESPIN;
		mouse_spinner_axis[x] = i;
	}
	else
	// parameter boxes
	if (y < NUM_LOOPS)
	{
		if (x>1 && x<8)
		{
			i = scr1_parms[x-2][y] + delta;
			if (x != 2)
				{if (i<0) i = 0;}
			else	{if (i < -999) i = -999;} // allow SPEED to be neg
			if (i>999) i = 999;
			scr1_parms[x-2][y] = i;
			scr1_parmlink[x-2][y] = -1;
		}
		else
		if (x == 1) // measures box //
		{
			i = scr1_measures[y] + delta;
			if (i < 0) i = 0;
			if (i > 8) i = 8;
			scr1_measures[y] = i;
			draw_measures_box(y);
		}
		else
		if (x == 0) // record box //
		{
			i = scr1_record[y] + delta;
			// do we need to create a new loop? //
			if (!isLoopFull(y) && (i == R_RECORD || i == L_RECORD) )
			{
				lockLoop(y);
				loopLength[y] = ( (1 << scr1_measures[y]) * 44100 * 60 / BPM) / 2;
				loopData[y] = malloc( loopLength[y]);
				memset(loopData[y], 0, loopLength[y]);
				unlockLoop(y);
			}
			
			if (i < NO_RECORD) i = NO_RECORD;
			if (i > R_RECORD) i = R_RECORD;
			scr1_record[y] = i;
			draw_record_box(y);
		}
		else
		if (x == 8) // fx box //
		{
			i = scr1_fx[y] + delta;
			if (i < NO_FX) i = NO_FX;
			if (i > YES_FX) i = YES_FX;
			scr1_fx[y]=i;
			draw_fx_box(y);
		}
		
		
	}
	else
	// BPM meter
	if (y == NUM_LOOPS)
	{
		i = BPM + delta;
		if (i < 10) i = 10;
		if (i > 500) i = 500;
		BPM = i;
		get_box_scr1(x,y,&l, &r, &t);
		sprintf(cBPM, "BPM %04d", BPM);
		DrawStr(cBPM, l, t, 0x80);
	}
	
}


void leave_box_scr1(int x, int y)
{
	int l, r, t;
	get_box_scr1(x, y, &l, &r, &t);
	blue_frame_ch(l, t, r, t);
}

void enter_box_scr1(int x, int y)
{
	int l, r, t;
	get_box_scr1(x, y, &l, &r, &t);
	active_frame_ch(l, t, r, t);
}


void get_box_scr1(int x, int y, int * left, int * right, int * top)
{
	// main part of form //
	if (y < NUM_LOOPS)
	{
		*left = LB_X + lb_frame[x*2 + 2];
		*right = LB_X + lb_frame[x*2 + 3];
		*top = LB_Y + 2 + 2*y;
		return;
	}
	// BPM meter
	if (y == NUM_LOOPS && x == 0)
		{*left = BP_X; *right = BP_X+8; *top = BP_Y; return;}
	// Load/Save Layout
	if (y == NUM_LOOPS)
	{
		*left = LS_X; *right = LS_X + 16; *top = LS_Y; return;
	}
	// mouse spinners
	if (x>7) x=7; // deal with extra box
	*left = MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*x+1;
	*right = MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*(x+1)-2;
	*top = MOUSE_SPINNERS_Y-2;
	return;
}


void draw_static_screen1()
{
  int i, j;   
  int n_lbf;
  char BPM_chars[6];
  n_lbf = sizeof(lb_frame)/sizeof(int); n_lbf /= 2;
  sprintf(BPM_chars, "BPM %04d", BPM);
  DrawStr(BPM_chars, BP_X, BP_Y, 0x80);
  blue_frame_ch(BP_X, BP_Y, BP_X+8, BP_Y);
  
  DrawStr("LOAD/SAVE LAYOUT", LS_X, LS_Y, 0x80);
  blue_frame_ch(LS_X, LS_Y, LS_X + 16, LS_Y);
  // draw loop title bar! //
  DrawStr(
  "LOOP  REC  MEASURES  SPEED  START  END  PHASE  VOL  PAN  FX",
		LB_X, LB_Y, 0x80);
  for (i=0;i<n_lbf;i++) 
	blue_frame_ch(LB_X+lb_frame[i*2], LB_Y, 
		LB_X + lb_frame[i*2 + 1], LB_Y);
  // draw loop data and boxes ... //
  for (j=0;j<NUM_LOOPS;j++)
  {
	blue_frame_ch(LB_X+lb_frame[0], LB_Y+2*j+2,
		LB_X + lb_frame[1], LB_Y+2*j+2);
	DrawAscChar('A'+j, LB_X + lb_frame[0], LB_Y+2*j+2, 0x80);
  	for (i=1;i<n_lbf;i++)
	blue_frame_ch(LB_X+lb_frame[i*2], LB_Y+2*j+2,
		LB_X + lb_frame[i*2 + 1], LB_Y+2*j+2);
	draw_measures_box(j);
	draw_record_box(j);
	draw_fx_box(j);
  }
  // mouse spinners
  for (i=0;i<NUM_MOUSE_SPINNERS;i++)
  {
	blue_frame_ch(MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*i+1,
			MOUSE_SPINNERS_Y,
		      MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*(i+1)-2,
			MOUSE_SPINNERS_Y+MOUSE_SPINNER_HEIGHT-1);
/*
	DrawStr("0000", MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*i+3,
			MOUSE_SPINNERS_Y, 0x80);
	DrawStr("NONE", MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*i+3,
			MOUSE_SPINNERS_Y+2, 0x80);
*/			
	blue_frame_ch(MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*i+1,
			MOUSE_SPINNERS_Y-2,
		      MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*(i+1)-2,
			MOUSE_SPINNERS_Y-2);
	DrawAscChar('F', MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*i+4,
			MOUSE_SPINNERS_Y-2, 0x80);
	DrawAscChar('1'+i, MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*i+5,
			MOUSE_SPINNERS_Y-2, 0x80);
  }
  // label oscillographs
  blue_frame_ch (LB_X + 61, LB_Y, LB_X + 77, LB_Y);
  DrawStr("WAVES", 68, LB_Y, 0x80);
  // cursor exists....
  enter_box_scr1(X_SCR1, Y_SCR1);
}


void refresh_mouse_spinner (int M)
{
	char val[10];
	char * axis;
	sprintf(val, "%04d", mouse_spinner_value[M]);
	DrawStr(val, MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*M+3,
			MOUSE_SPINNERS_Y, 0x80);
	switch (mouse_spinner_axis[M])
	{
	default:
	case NO_AXIS: axis = "NONE"; break;
	case X_AXIS: axis = " X  "; break;
	case Y_AXIS: axis = " Y  "; break;
	case MINUS_X_AXIS: axis = " -X "; break;
	case MINUS_Y_AXIS: axis = " -Y "; break;
	case X2_AXIS: axis = " 2X "; break;
	case Y2_AXIS: axis = " 2Y "; break;
	case MINUS_X2_AXIS: axis = "-2X "; break;
	case MINUS_Y2_AXIS: axis = "-2Y "; break;
	case WHEEL1: axis = " W1 "; break;
	case WHEEL2: axis = " W2 "; break;
	case WHEEL3: axis = " W3 "; break;
	case MINUS_WHEEL1: axis = "-W1"; break;
	case MINUS_WHEEL2: axis = "-W2"; break;
	case MINUS_WHEEL3: axis = "-W3"; break;
	};
	
	DrawStr(axis, MOUSE_SPINNERS_X+MOUSE_SPINNER_WIDTH*M+3,
			MOUSE_SPINNERS_Y+2, 0x80);
	
}

void refresh_mouse_spinners()
{
	int M; for (M=0;M<8;M++) refresh_mouse_spinner(M);
}
	


void draw_bpm_meter(int BPM, int ticks, int X, int Y)
{
  // draws a light show!  ticks are time in 44100's of a second //
  // BPM is beats per minute.                                   //
  unsigned int cycle_ticks;
  char lite_bar[6]; // 4 measure, 2 measure, .. 1/8 //
  char bpm_text[5];
  unsigned int bar_ticks[6];
  int i;
  cycle_ticks = 60 * 44100 / BPM; 
  bar_ticks[0]=cycle_ticks * 4;
  for (i=1;i<6;i++) bar_ticks[i]=bar_ticks[i-1]/2;
  // now, for each entry in bar_ticks, see if ticks is
  // in the first half of the cycle.  if so, lite bar
  for (i=0;i<6;i++)
    if ((ticks%bar_ticks[i])<(bar_ticks[i]/2)) lite_bar[i]=1;
    else lite_bar[i]=0;
  // create text for BPM number
  bpm_text[4]=0; for (i=3;i>=0;i--)
    {
      bpm_text[i]=0x30+BPM%10;
      BPM /= 10;
    }
  // render the whole mess!
  for (i=0;i<6;i++)
    { // ascii Q is charset circle //
      DrawChar('Q', X+i, Y, lite_bar[i]?0xb0:0x60);
      DrawChar('Q', X+15-i, Y, lite_bar[i]?0xb0:0x60);
      DrawStr(bpm_text, X+6, Y, lite_bar[2]?0xb0:0x60);
    }
}


void draw_vu_bar(int V, int X, int Y, int Dir)
{
	unsigned char VBar[128];
	int i; char col;
	V = (V<0)?-V:V;
	V = (V>127)?127:V;
	for (i=0;i<128;i++)
	{
		if (i > V) col = 0;
		else
		{
			col = 11;
			if (i < RED_VU) col = 10;
			if (i < ORG_VU) col = 9;
			if (i < YEL_VU) col = 8;
		}
		if (Dir>0) VBar[i]=col;
		else	VBar[127-i]=col;
	}
	
	for (i=1;i<8;i++)
		vga_drawscansegment (VBar, X*8, Y*8+i, 128);

	box_xy(X*8-1, Y*8, X*8+128+1, Y*8+8, 15);

}


void active_frame_xy(int, int, int, int);

void active_frame_ch(int X1, int Y1, int X2, int Y2)
{
	active_frame_xy(X1*8-5, Y1*8-5, X2*8 + 11, Y2*8 + 11);
}

void active_frame_xy(int X1, int Y1, int X2, int Y2)
{
	int i;
	int x1, x2, y1, y2;
	for (i=0;i<4;i++)
	{
		vga_setcolor((i<3)?12+i:6);
		x1 = X1 + i; x2 = X2 - i;
		y1 = Y1 + i; y2 = Y2 - i;
		vga_drawline(x1,y1,x2,y1);
		vga_drawline(x2,y1,x2,y2);
		vga_drawline(x2,y2,x1,y2);
		vga_drawline(x1,y2,x1,y1);
	}

}


void blue_frame_ch(int X1, int Y1, int X2, int Y2)
{
	blue_frame_xy(X1*8 - 5, Y1*8 - 5, X2*8 + 11, Y2*8 + 11);
}

void blue_frame_xy(int X1, int Y1, int X2, int Y2)
{
	int i;
	int x1, x2, y1, y2;
	for (i=0;i<4;i++)
	{
		vga_setcolor(1+i);
		x1 = X1 + i; x2 = X2 - i;
		y1 = Y1 + i; y2 = Y2 - i;
		vga_drawline(x1,y1,x2,y1);
		vga_drawline(x2,y1,x2,y2);
		vga_drawline(x2,y2,x1,y2);
		vga_drawline(x1,y2,x1,y1);
	}

}

void box_xy(int X1, int Y1, int X2, int Y2, int Col)
{	////////////////////////////////////////////////////////////////
	// horizontal segs are now optimized with vga_drawscansegment //
	// this requires 4 outs for the entire hline, as opposed for  //
	// each point.			////////////////////////////////
	// somebody really ought to fix vga_line!	////////////////
	////////////////////////////////////////////////////////////////
	
	char HSeg[640];
	vga_setcolor(Col);
	memset(HSeg, Col, X2 + 1 - X1);
	//vga_drawline(X1, Y1, X2, Y1);
	vga_drawscansegment(HSeg, X1, Y1, X2 + 1 - X1);
	vga_drawline(X2, Y1, X2, Y2);
	//vga_drawline(X2, Y2, X1, Y2);
	vga_drawscansegment(HSeg, X1, Y2, X2 + 1 - X1);
	vga_drawline(X1, Y2, X1, Y1);
}

void draw_oscilloscope(int L, int X, int Y)
{
	int XP, YP, i, j;
	int nData; short * data;
	short sval; short asval;
	float step, sample;
	const int XPIXELS = 128;
	static char * Scanlines[16];
	static int first_time = 1;
	XP = X*8, YP = Y*8 - 4;
	data = (short *) loopData[L];
	nData = loopLength[L] / 2;
	if (first_time)
	{
		first_time = 0;
		for (i=0;i<16;i++) Scanlines[i]=malloc(XPIXELS);
	}
	

	// if no wave data, just do a bar //
	if ( (data == NULL) || (nData == 0) )
	{
		for (i=0;i<16;i++) memset(Scanlines[i], 0x03, XPIXELS);
	}
	else
	// draw oscilloscope trace
	{
		for (i=0;i<16;i++) memset(Scanlines[i], 0x03, XPIXELS);
		sample = 0.0f; step = (float) nData / (float) XPIXELS;
		
		for (i=0;i<XPIXELS;i++)
		{
			sval = data[(int) sample];
			sample += step;
			asval = (sval < 0) ? -sval : sval;
			j = 0;
			if (asval > 4) j = 1;
			if (asval > 16) j = 2;
			if (asval > 64) j = 3;
			if (asval > 256) j = 4;
			if (asval > 1024) j = 5;
			if (asval > 4096) j = 6;
			if (asval > 16384) j = 7;
			for (;j>=0;j--)
			{
				*(Scanlines[8+j]+i) = 0x09;
				*(Scanlines[7-j]+i) = 0x09;
			}
			// safety against inexact floats //
			if ((int)sample >= nData) break; 
		}
	// warning -- loopPos[] in CHARS, not SHORTS! //
	j = (int) ((float)loopPos[L] / step) / 2; 
	j = (j<0)?0:(j >= XPIXELS) ? XPIXELS - 1 : j;
	for (i=0;i<16;i++)
		*(Scanlines[i]+j) = 0x0f;

	j = (int) ((float)loopPhasedPos[L] / step);
	j = (j<0)?0:(j >= XPIXELS) ? XPIXELS - 1 : j;
	for (i=0;i<16;i++)
		*(Scanlines[i]+j) = 0x0b;

	
	}

	// render to the screen
	for (i=0;i<16;i++)
	{
		vga_drawscansegment(Scanlines[i], XP, YP+i, XPIXELS);
	}
	
	
}


